/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BINARYFILE_H
#define BINARYFILE_H

#include <fstream>
#include <string>
#include "SDL.h"

class InputBinaryFile
{
public:
	InputBinaryFile(const std::string& filename);
	Uint64 read(std::size_t n);
	Uint64 readX(std::size_t n);
	std::string readS();
	
private:
	std::ifstream in;
	Uint8 bufferData;
	std::size_t bufferSize;
};

class OutputBinaryFile
{
public:
	OutputBinaryFile(const std::string& filename);
	~OutputBinaryFile();
	void write(std::size_t n, Uint64 value);
	void writeX(std::size_t n, Uint64 value);
	void writeS(const std::string& str);
	
private:
	std::ofstream out;
	Uint8 bufferData;
	std::size_t bufferSize;
};

int calculateBitsNeeded(Uint64 value);

#endif
