/*
 * Copyright 2010, 2011, 2014, 2016 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CARSELECTIONSTATE_H
#define CARSELECTIONSTATE_H

#include "GameState.h"
#include "MenuText.h"
#include <vector>

class Network;

enum  CarSelectionMode
{
	CAR_SELECTION_NORMAL,
	CAR_SELECTION_NETWORK_CREATE,
	CAR_SELECTION_NETWORK_JOIN,
	CAR_SELECTION_TIME_TRIAL
};

class CarSelectionState : public GameState
{
public:
	CarSelectionState(CarSelectionMode mode, Network* net = 0, int player = 0, Uint8 reservedCars = 0);
	virtual void setStateInfo(int);
	virtual void onEvent(const SDL_Event& event);
	virtual void update();
private:

	bool selectCar(int i, bool select = true);
	void nextCar();
	void prevCar();
	void selectCar();
	void updateCars();
	void mouseMove(int x, int y);
	void mouseClick(int x, int y);
	bool proceed();
	
	CarSelectionMode mode;
	int selectedCar;
	std::vector<int> chosenCars;
	RenderObject renderObjects[8];
	
	int player;
	Uint8 reservedCars;
	Network* net;
	
	MenuText playerText;
	double rotation;
	bool isSelected;
	int hoverCar;
	
	MenuText timeoutText;
	int timeoutSeconds;
	Uint32 timeoutStart;
};

#endif
