/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef COLOR_H
#define COLOR_H

#include "SDL.h"
#include <string>

typedef Uint32 Color;

const Color BLACK = 0x000000;
const Color WHITE = 0xFFFFFF;

const Color BACKGROUND_COLOR  = 0x787CE0;
const Color BACKGROUND_COLOR2 = 0x6266B8;
const Color BACKGROUND_COLOR3 = 0x5A5EA8;
const Color TITLE_COLOR = 0xFFDD10;
const Color TITLE_BOX_COLOR = 0xDCDCDC;
const Color MENU_INACTIVE_COLOR = 0xFFFFFF;
const Color MENU_ACTIVE_COLOR = 0x20FF20;
const Color MENU_ACTIVE_COLOR2 = 0xFF2020;
const Color TEXT_COLOR = 0xE8E8E8;
const Color TEXT_BORDER_COLOR = 0x000000;
const Color CHAT_COLOR = 0xFFFFFF;
const Color CHAT_COLOR2 = 0xDFDFDF;
const Color DEFAULT_COLORKEY = 0xFF00FF;
const Color WINNER_COLOR = 0xFFDD10;
const Color BOX_BORDER_COLOR = 0x010101;
const Color BOX_SHADOW_COLOR = 0xb3b3b3;
const Color BOX_INNER_COLOR = 0xc8c8c8;

const Color TIME_WEAK_HIGHLIGHT_COLOR = 0xe8daa0;
const Color TIME_STRONG_HIGHLIGHT_COLOR = 0xfff610;

inline Uint8 red(Color c)
{
	return (c >> 16) & 0xFF;
}

inline Uint8 green(Color c)
{
	return (c >> 8) & 0xFF;
}

inline Uint8 blue(Color c)
{
	return (c >> 0) & 0xFF;
}

Color carColor(int car);
std::string carColorName(int car);

#endif
