/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GRAPHICSSETTINGSMENU_H
#define GRAPHICSSETTINGSMENU_H

#include "GameState.h"
#include "Menu.h"
#include "Settings.h"

class GraphicsSettingsMenu : public GameState
{
public:
	GraphicsSettingsMenu();
	~GraphicsSettingsMenu();
	virtual void onEvent(const SDL_Event& event);
	virtual void validateTypedValue(const std::string* strValue, std::string& inputString);
	virtual void onValueUpdate(int* intValue);
	virtual void onValueUpdate(std::string* strValue);
private:
	int scaler;
	int stretch;
	int fullscreen;
	int pointer;
	int scalePointer;
	Settings::Graphics oldSettings;
	std::string resolution;
	bool save;
	bool cancel;
};

#endif

