/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef HUMANPLAYERSETTINGSMENU_H
#define HUMANPLAYERSETTINGSMENU_H

#include "GameState.h"
#include "Menu.h"

class Driver;

class HumanPlayerSettingsMenu : public GameState
{
public:
	HumanPlayerSettingsMenu();
	~HumanPlayerSettingsMenu();
	virtual void onEvent(const SDL_Event& event);
	virtual void onValueUpdate(std::string* strValue);
private:
	void updatePlayer();
	void updateDevice();
	void updateControl(int i);

	int player;
	std::string name;
	int device;
	bool saveAction;
	bool cancelAction;
	int mode;
	bool enterControlMode[4];
	std::vector<Driver*> drivers[8];
	std::string names[8];
	int deviceIndices[8];
};

#endif



