/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "NetworkBlankState.h"
#include "Network.h"
#include "StateManager.h"

NetworkBlankState::NetworkBlankState(Network* net)
:	net(net)
{
}

void NetworkBlankState::update()
{
	net->step();
	GameState* gs = net->getNewGameState();
	if (gs)
	{
		StateManager::getInstance().enter(gs, 0);
	}
}
