/*
 * Copyright 2014, 2016 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NETWORKMENU_H
#define NETWORKMENU_H

#include "GameState.h"

class Network;
class GameList;

class NetworkMenu : public GameState
{
public:
	NetworkMenu(Network* net);
	virtual void update();
	virtual void onEvent(const SDL_Event& event);
private:
	void updatePlayersOnlineCounter();

	Network* net;
	bool joinAction;
	bool hostAction;
	bool disconnectAction;
	GameList& gameList;
	RenderObject playersWaitingRenderObject;
	int numberOfPlayersWaiting;
};

#endif
