/*
 * Copyright 2014, 2016 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NETWORKMESSAGE_H
#define NETWORKMESSAGE_H

#include "SDL_net.h"
#include <string>

class NetworkMessage
{
public:
	NetworkMessage();
	void write8(Uint8 value);
	void write16(Uint16 value);
	void write32(Uint32 value);
	void write64(Uint64 value);
	void writeAddress(const IPaddress& addr);
	void writeString(const std::string& str);
	Uint8 read8();
	Uint16 read16();
	Uint32 read32();
	Uint64 read64();
	IPaddress readAddress();
	std::string readString();
	UDPpacket& getPacket();
	void reset();
private:
	static const int MAX_MESSAGE_LENGTH = 512;
	Uint8 buffer[MAX_MESSAGE_LENGTH];
	int readPos;
	UDPpacket packet;
};

#endif
