/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef NETWORKSETTINGSMENU_H
#define NETWORKSETTINGSMENU_H

#include "GameState.h"
#include "Menu.h"

class NetworkSettingsMenu : public GameState
{
public:
	NetworkSettingsMenu();
	virtual void onEvent(const SDL_Event& event);
	virtual void onValueUpdate(std::string* strValue);
private:

	std::string lanPorts;
	std::vector<Uint16> internetPortsVec;
	std::string internetPorts;
	std::vector<Uint16> lanPortsVec;
	std::string server;
	int maxConnections;
	int chatFont;
	int maxChatMessages;
	std::string chatMessageDuration;
	int chatMessageDurationValue;
	
	bool save;
	bool cancel;
};

#endif
