/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TRACKINPUTBUFFER_H
#define TRACKINPUTBUFFER_H

#include <cstddef>
#include "SDL.h"

class TrackInputBuffer
{
public:
	static const std::size_t SIZE = 50;
	TrackInputBuffer();
	Uint32& next();
	Uint32& operator[](std::size_t i);
private:
	Uint32 inputs[SIZE];
	std::size_t current;
};

inline Uint32 getInput(Uint32 input, int player)
{
	return (input >> (4 * player)) & 0xF;
}

inline void setInput(Uint32& input, int player, Uint32 playerInput)
{
	Uint32 bitshifts = (4 * player);
	Uint32 mask = 0xF << bitshifts;
	input = (input & ~mask) | (playerInput << bitshifts);
}

#endif
