/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TRACKSTATEBUFFER_H
#define TRACKSTATEBUFFER_H

#include "TrackState.h"
#include <cstddef>

class TrackStateBuffer
{
public:
	static const std::size_t SIZE = 10;
	TrackStateBuffer();
	~TrackStateBuffer();
	void setCars(int nCars);
	void removeCar(int carId, int nCars);
	TrackState& next();
	TrackState& operator[](std::size_t i);
private:
	TrackState states[SIZE];
	std::size_t current;
};

#endif


