/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TRACKSETTINGSMENU_H
#define TRACKSETTINGSMENU_H

#include "GameState.h"
#include "Menu.h"
#include "Settings.h"

class TracksSettingsMenu : public GameState
{
public:
	TracksSettingsMenu();
	virtual void onEvent(const SDL_Event& event);
	virtual void validateTypedValue(const std::string* strValue, std::string& inputString);
	virtual void onValueUpdate(std::string* strValue);
	virtual void onValueUpdate(int* intValue);
	void updateTilesetInfo();
private:
	class RangeItem
	{
	public:
		RangeItem(const std::string& text, int* value1, int* value2, int min, int max, const std::string& unit = "");
		void addTo(Menu& menu);
		void validateTypedValue(const std::string* strValue, std::string& inputString);
		void onValueUpdate(std::string* strValue);
		void inc(Menu& menu);
		void dec(Menu& menu);
		void maximize(Menu& menu);
		void minimize(Menu& menu);
	private:
		void updateValue();
		int* value1;
		int* value2;
		int min;
		int max;
		std::string text;
		std::string value;
		std::string unit;
	};
	std::vector<RangeItem> rangeItems;
	Settings::Tracks trackSettings;
	bool save;
	bool cancel;
};

#endif
