/*
 * Copyright 2010, 2011, 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "str.h"
#include <sstream>
#include <climits>
#include <cctype>

std::string int2string(int i)
{
	std::ostringstream osstream;
	osstream << i;
	return osstream.str();
}

std::string time2string(int t, bool showMilliseconds)
{
	std::ostringstream  s;
	if (t == INT_MAX) // DNF
	{
		s << "DNF";
	}
	else
	{
		s << (t / 600000);
		s << (t / 60000) % 10;
		s << ":";
		s << (t / 10000) % 6;
		s << (t / 1000) % 10;
		s << ":"; 
		s << (t / 100) % 10;
		s << (t / 10) % 10;
		if (showMilliseconds)
		{
			s << t  % 10;
		}
	}
	return s.str();
}

void toLower(std::string& str)
{
	for (std::size_t i = 0; i < str.length(); ++i)
	{
		str[i] = std::tolower(str[i]);
	}
}
